Subject: RE: [BUGS] Git v2.51.2 on NonStop

From: <[email-masked]>
Date: Thu, 30 Oct 2025 10:59:34 -0400

On October 30, 2025 9:53 AM, D. Ben Knoble wrote:
>On Wed, Oct 29, 2025 at 8:25 PM <[email-masked]> wrote:
>>
>> What appears to be happening is that the Make environment is only
>> using SHELL=/bin/bash for the outer processing but not the inner
>> #!/bin/sh of t7900. The system is using /bin/sh as specified, which
>> uses ksh, not bash, which is the trace above. When I run the
>> individual tests with bash, the error reported goes away. The problem
>> is, with my version of Gnu Make, 4.1.2, the SHELL variable is only
>> being replaced for the command processing of each recipe. Once the
>> system loader sees the shebang of #!/bin/sh, /bin/sh is used as
>> requested, and fails out. This means that I have to remember to manually run
>each test that fails with bash instead of the default. It is frustrating and now adds
>hours to my manual evaluation of the CI/CD results.
>>
>> The trace above is from sh, not bash because of this.
>>
>> With Frustration,
>> Randall
>
>Is this the only ksh-induced failure? And if so, what is inducing the failure—is it
>something the test library can work around, or is the system {k,}sh not behaving
>portably here?
>
>My preference would be towards making your setup "just work" assuming there's
>not a clear contradiction of portable standards somewhere.

I think there were other ksh issues, mostly the SHELL= setting in make. I will report
others on a per test case basis when they come. The SHELL_PATH= definitely is
using bash, so that fix suggested by Peff is working out nicely.

Regards,
Randall